package com.hncy.service.wechat.applet.biz.service;

import com.hncy.common.dto.ResultBean;
import com.hncy.service.wechat.applet.biz.dto.ComponentPictureDto;
import com.hncy.service.wechat.applet.biz.entity.ComponentDetail;
import com.baomidou.mybatisplus.extension.service.IService;
import com.hncy.service.wechat.applet.biz.vo.ComponentAcquisitionVo;
import com.hncy.service.wechat.applet.biz.vo.PatrolInspectionComponentsSumVo;
import com.hncy.service.wechat.applet.biz.vo.PatrolInspectionSumVo;

import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 部件详情 服务类
 * </p>
 *
 * @author cs
 * @since 2021-11-02
 */
public interface ComponentDetailService extends IService<ComponentDetail> {

    /**
     * @Description 获取城市系统的部件（内部调用）
     * @Date 2021/11/2 13:43
     * @param
     * @return
     */
    ResultBean getComponentByCtiySys();

    /**
     * @Description 获取城市部件类型以及立案条件
     * @Date 2021/11/2 13:44
     * @param
     * @return
     */
    ResultBean getComponentTypeAndRegCondByCtiySys();

    /**
     * @Description 判断AI扫描出的部件是否存在于后台数据库
     * @Date 2021/11/3 9:51
     * @param componentTypeName
     * @param xCode
     * @param yCode
     * @return List<AIScanComponentsVo>
     */
    ResultBean<ComponentAcquisitionVo> judgeAIComponentIsExist(String componentTypeName, String xCode, String yCode);

    /**
     * @Description 部件采集
     * @Date 2021/11/3 14:07
     * @param componentName
     * @param componentCode
     * @param componentSuperName
     * @param componentSuperCode
     * @param componentTypeName
     * @param componentTypeCode
     * @param componentAddress
     * @param xCode
     * @param yCode
     * @param patrolInspectionTime
     * @param regCondCode
     * @param regCondName
     * @param issueDescription
     * @param pictureIds
     * @param collectorNickName
     * @return
     */
    ResultBean componentAcquisition(String componentName,
                                    String componentCode,
                                    String componentSuperName,
                                    String componentSuperCode,
                                    String componentTypeName,
                                    String componentTypeCode,
                                    String componentAddress,
                                    String xCode,
                                    String yCode,
                                    LocalDateTime patrolInspectionTime,
                                    String regCondCode,
                                    String regCondName,
                                    String issueDescription,
                                    List<String> pictureIds,
                                    String collectorNickName);
    /**
     * @Description 获取今日巡检数，部件采集总数，上报采集总数
     * @Date 2021/11/3 15:27
     * @param
     * @return
     */
    ResultBean<PatrolInspectionSumVo> selectTodaySum();

    /**
     * @Description 获取今日巡检部件的类别和每个类别下的总数
     * @Date 2021/11/3 16:55
     * @param
     * @return
     */
    ResultBean<List<PatrolInspectionComponentsSumVo>> selectTodayComponentsTypeSum();

    /**
     * @Description 添加巡检时间记录
     * @Date 2021/11/3 19:45
     * @param patrolInspectionTime
     * @param componentLogos
     * @return
     */
    ResultBean savepatrolInspectionTime(LocalDateTime patrolInspectionTime, List<String> componentLogos);
}
